import { useContext, createContext, useMemo, useState, useRef, useCallback, useEffect } from 'react';
import UniversalRouter from 'universal-router';
import { parsePath, createPath, createBrowserHistory } from 'history';
import { jsx, Fragment } from 'react/jsx-runtime';

var i = 1;
function uniqId() {
  return i++;
}
function cancelPromise() {
  return new Promise(function () {});
}
function createCurrentGuard() {
  var current;
  return [function currentGuard(promise) {
    var cur = uniqId();
    current = cur;
    return promise.then(function (result) {
      return current === cur ? result : cancelPromise();
    }).catch(function (err) {
      return current === cur ? Promise.reject(err) : cancelPromise();
    });
  }, function cancel() {
    current = undefined;
  }];
}

var _excluded$1 = ["routes", "history", "children"],
    _excluded2 = ["pathname", "state"];

function ownKeys$1(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) { symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); } keys.push.apply(keys, symbols); } return keys; }

function _objectSpread$1(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys$1(Object(source), true).forEach(function (key) { _defineProperty$1(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys$1(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty$1(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _unsupportedIterableToArray(arr) || _nonIterableSpread(); }

function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _iterableToArray(iter) { if (typeof Symbol !== "undefined" && iter[Symbol.iterator] != null || iter["@@iterator"] != null) return Array.from(iter); }

function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) return _arrayLikeToArray(arr); }

function _objectWithoutProperties$1(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose$1(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose$1(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { var _i = arr == null ? null : typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"]; if (_i == null) return; var _arr = []; var _n = true; var _d = false; var _s, _e; try { for (_i = _i.call(arr); !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }
var Context = /*#__PURE__*/createContext(null);

var _createCurrentGuard = createCurrentGuard(),
    _createCurrentGuard2 = _slicedToArray(_createCurrentGuard, 2),
    currentGuard = _createCurrentGuard2[0],
    cancelAll = _createCurrentGuard2[1];

function BaseRouter(_ref) {
  var routes = _ref.routes,
      history = _ref.history,
      children = _ref.children,
      rest = _objectWithoutProperties$1(_ref, _excluded$1);

  var router = useMemo(function () {
    return new UniversalRouter(routes, rest);
  }, [routes].concat(_toConsumableArray(Object.values(rest)))); // TODO: 移到上层 context

  var _useState = useState(),
      _useState2 = _slicedToArray(_useState, 2),
      loading = _useState2[0],
      setLoading = _useState2[1];

  var _useState3 = useState(),
      _useState4 = _slicedToArray(_useState3, 2),
      view = _useState4[0],
      setView = _useState4[1];

  var viewStackRef = useRef([]);
  var locationStackRef = useRef([history.location]);
  var cancel = useCallback(function () {
    setLoading(function (l) {
      if (l && l.status === 'pending') {
        cancelAll();
        return undefined;
      }

      return l;
    });
  }, []);

  var rejectLoading = function rejectLoading(key) {
    return function (e) {
      setLoading({
        key: key,
        status: 'rejected'
      });
      throw e;
    };
  };

  var navigate = useCallback(function (to) {
    var _history$location$sta;

    var _ref2 = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {},
        state = _ref2.state,
        replace = _ref2.replace;

    to = router.baseUrl + to;

    var location = _objectSpread$1(_objectSpread$1({
      pathname: '',
      search: '',
      hash: ''
    }, parsePath(to)), {}, {
      state: state
    });

    var nextIndex = (((_history$location$sta = history.location.state) === null || _history$location$sta === void 0 ? void 0 : _history$location$sta.index) || 0) + (replace ? 0 : 1);
    var key = uniqId();
    setLoading({
      key: key,
      status: 'pending'
    });
    currentGuard(router.resolve({
      pathname: location.pathname,
      location: location
    })).then(function (resolvedView) {
      locationStackRef.current = [].concat(_toConsumableArray(locationStackRef.current.slice(0, nextIndex)), [location]);
      viewStackRef.current = [].concat(_toConsumableArray(viewStackRef.current.slice(0, nextIndex)), [resolvedView]);
      history[replace ? 'replace' : 'push'](to, {
        index: nextIndex,
        locationStack: locationStackRef.current
      });
      setLoading({
        key: key,
        status: 'resolved'
      });
    }).catch(rejectLoading(key));
  }, [router]);
  var refresh = useCallback(function () {
    var _history$location = history.location,
        pathname = _history$location.pathname,
        state = _history$location.state,
        restLocation = _objectWithoutProperties$1(_history$location, _excluded2);

    return navigate(createPath(_objectSpread$1(_objectSpread$1({}, restLocation), {}, {
      pathname: pathname.slice(router.baseUrl.length)
    })), {
      replace: true,
      state: locationStackRef.current[state.index].state
    });
  }, [navigate]);
  useEffect(function () {
    var _history$location$sta2;

    var locationStack = ((_history$location$sta2 = history.location.state) === null || _history$location$sta2 === void 0 ? void 0 : _history$location$sta2.locationStack) || locationStackRef.current;
    locationStackRef.current = locationStack;
    var key = uniqId();
    setLoading({
      key: key,
      status: 'pending'
    });
    Promise.all(locationStack.map(function (l) {
      return router.resolve({
        pathname: createPath(l),
        location: l
      });
    })).then(function (views) {
      viewStackRef.current = views;
      history.replace(createPath(history.location), history.location.state);
      setLoading({
        key: key,
        status: 'resolved'
      });
    }).catch(rejectLoading(key));
    return cancel;
  }, [router]);
  useEffect(function () {
    return history.listen(function (_ref3) {
      var _location$state;

      var action = _ref3.action,
          location = _ref3.location;
      cancel();
      var index = ((_location$state = location.state) === null || _location$state === void 0 ? void 0 : _location$state.index) || 0;
      setView(viewStackRef.current[index]);

      if (action === 'POP') {
        history.replace(createPath(history.location), _objectSpread$1(_objectSpread$1({}, history.location.state), {}, {
          locationStack: locationStackRef.current
        }));
      }
    });
  }, [history]);
  return /*#__PURE__*/jsx(Context.Provider, _objectSpread$1(_objectSpread$1({}, rest), {}, {
    value: {
      history: history,
      router: router,
      loading: loading,
      setLoading: setLoading,
      view: view,
      setView: setView,
      navigate: navigate,
      refresh: refresh,
      cancel: cancel
    },
    children: typeof children === 'undefined' ? view : children
  }));
}
function Router(props) {
  var history = createBrowserHistory();
  return /*#__PURE__*/jsx(BaseRouter, _objectSpread$1(_objectSpread$1({}, props), {}, {
    history: history
  }));
}
function useRouter() {
  return useContext(Context);
}
function useLoading() {
  return useContext(Context).loading;
}
function View() {
  var _useRouter = useRouter(),
      view = _useRouter.view;

  return /*#__PURE__*/jsx(Fragment, {
    children: view
  });
}

var _excluded = ["to"];

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) { symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); } keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }
function Link(_ref) {
  var to = _ref.to,
      rest = _objectWithoutProperties(_ref, _excluded);

  var _useRouter = useRouter(),
      history = _useRouter.history,
      navigate = _useRouter.navigate,
      router = _useRouter.router;

  function handleClick(e) {
    e.preventDefault();
    navigate(to);
  }

  return (
    /*#__PURE__*/
    // eslint-disable-next-line jsx-a11y/anchor-has-content
    jsx("a", _objectSpread(_objectSpread({}, rest), {}, {
      href: router.baseUrl + history.createHref(to),
      onClick: handleClick
    }))
  );
}

export { BaseRouter, Link, Router, View, useLoading, useRouter };
//# sourceMappingURL=native-router-react.es.js.map
